﻿// BSLLS:CommonModuleInvalidType-off

#Область ПрограммныйИнтерфейс

#КонецОбласти

#Область СлужебныйПрограммныйИнтерфейс

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

&Вместо("ПередЗаписью")
Процедура оптерп_ПередЗаписью(ДокументОбъект, Отказ, РежимЗаписи, РежимПроведения) Экспорт
	
	Если НЕ оптерп_Правка
		.Включена(оптерп_Идентификатор.ИсправлениеДокументов_ПередЗаписью_ОптимизацияПроведен()) Тогда
		ПродолжитьВызов(ДокументОбъект, Отказ, РежимЗаписи, РежимПроведения);		
		Возврат;
	КонецЕсли;
	
	Если НЕ ЗначениеЗаполнено(ДокументОбъект.Ссылка) Тогда
		Возврат;
	КонецЕсли;

	Запрос = Новый Запрос;
	Запрос.Текст =
	"ВЫБРАТЬ
	|	РеестрДокументов.Ссылка КАК Ссылка
	// ::: +++ Добавим поле в выборку
	|	, РеестрДокументов.Проведен КАК Проведен
	// ::: +++ 
	|ИЗ
	// BSLLS:QueryToMissingMetadata-off - метаданные не проверяем
	|	РегистрСведений.РеестрДокументов КАК РеестрДокументов
	// BSLLS:QueryToMissingMetadata-on
	|ГДЕ
	|	РеестрДокументов.СторнируемыйДокумент = &Ссылка
	// ::: --- Уберем условие на ресурс Проведен
	// |	И РеестрДокументов.Проведен
	// ::: --- 
	|";
	Запрос.УстановитьПараметр("Ссылка", ДокументОбъект.Ссылка);
	Выборка = Запрос.Выполнить().Выбрать();
	// ::: *** Проверим только записи с Проведен
	// BSLLS:CommentedCode-off - комментируем типовой код
	// Если Выборка.Следующий() Тогда
	// BSLLS:CommentedCode-on
	Пока Выборка.Следующий() Цикл
		Если Выборка.Проведен Тогда
	// ::: *** 	
		Если ТипЗнч(Выборка.Ссылка) = Тип("ДокументСсылка.Сторно") Тогда
			ТекстСообщения = НСтр("ru = 'На основании документа введен документ ""Сторно"".
				                        |Запись документа невозможна.';
				                        |en = 'The ""Reverse transaction"" document is entered based on the document.
				                        |Cannot save document.'");
		Иначе
			ТекстСообщения = НСтр("ru = 'На основании документа введено исправление.
				                        |Запись документа невозможна.';
				                        |en = 'The correction is entered based on the document.
				                        |Cannot save document.'");
		КонецЕсли;
		ОбщегоНазначения.СообщитьПользователю(ТекстСообщения, , , , Отказ);
	// ::: *** 		
		Прервать;
		
		КонецЕсли;
	КонецЦикла;
	// BSLLS:CommentedCode-off - комментируем типовой код
	// КонецЕсли;
	// BSLLS:CommentedCode-on
	// ::: *** 	
	
КонецПроцедуры

#КонецОбласти

// BSLLS:CommonModuleInvalidType-on